const veterinarianController = {};
const config = require('../config/common.config');
const jwt = require('jsonwebtoken');
const stripe = require('stripe')('sk_test_51Gf0TaDf4p1HjB0rVdcdf2elyG63YZzbKxLQzRCNEdTSVUiK6NMzjOVo9DmPAgfeHwIt8l8wglRuEq01GV62UKxn00hXPkEwl6');
const { contactUsMail, registerMail, forgotPasswordMail } = require("../utils/ContentProvider");
const fs = require('fs');
const moment = require('moment');
const publicPath = basedir + "/public/";
const ResponseFormatter = require("../utils/response-formatter");
const formatter = new ResponseFormatter();
const { ObjectId } = require('mongodb')

const UserMaster = require("../models/UserMaster");
const AdminMaster = require("../models/AdminMaster");
const OTPMaster = require('../models/OTPMaster');
const PetTypeMaster = require("../models/PetTypeMaster");
const ProductMaster = require('../models/ProductMaster');
const NotificationMaster = require('../models/NotificationMaster');
const ConsultationMaster = require('../models/ConsultationMaster');
const PriscribeMaster = require('../models/PriscribeMaster');
const MessageMaster = require('../models/MessageMaster');
const BankDetailsMaster = require('../models/BankDetailMaster');
const sendSMS = require('../utils/sendSMS');
const { sendFirebaseNotification } = require('../utils/notification');
const { createSubAccount, payoutStripe, updateSubAccount, returnPayment } = require('./payment.controller');
const PayoutHistoryMaster = require('../models/PayoutHistoryMaster');
const commonConfig = require('../config/common.config');
const TransactionMaster = require('../models/TransactionMaster');

/** APIs */
function makeid(length) {
    let result = '';
    let characters = '0123456789';
    let charactersLength = characters.length;
    for (let i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() *
            charactersLength));
    }
    return result;
}

// veterinarianController.refreshToken = async function (req, res) {
//     const { user_id } = req.body;
//     try {
//         let checkUser = await userController.getUserDetail(user_id);
//         if (checkUser == null) {
//             return res.send(formatter.formatResponse({}, 0, "invalid_user_id", false));
//         }

//         let token = jwt.sign({ userId: user_id }, config.jwt.secret, { expiresIn: config.jwt.token_expiry });
//         return res.send(formatter.formatResponse({ token: token }, 0, "token_updated_success", true));

//     } catch (errorCode) {
//         console.error("userController.refreshToken - ", errorCode);
//         return res.send(formatter.formatResponse({}, 0, errorCode, false));
//     }
// }

veterinarianController.getUserDetail = async (user_id) => {
    let checkUser = await UserMaster.findOne({ _id: user_id, deleted_at: null }).exec();
    return checkUser;
}

veterinarianController.sendOtp = async (req, res) => {
    const { ccode, phone, email, is_signup } = req.body;
    try {
        await OTPMaster.deleteOne({ phone: phone, ccode: ccode });
        if (is_signup == "true") {
            let userResponseObj = await UserMaster.findOne({ phone: phone, ccode: ccode, user_type: "veterinarian", deleted_at: null }).setOptions({ ignorePreHooks: true });


            if (userResponseObj) {

                return res.send(formatter.formatResponse({}, 0, "already_register_phone", false))
            }

            let emailExist = await UserMaster.findOne({ email: email, user_type: "veterinarian", deleted_at: null });
            if (emailExist) {
                return res.send(formatter.formatResponse({}, 0, "already_register_email", false))
            }
            let d;
            d = new Date();
            d.setSeconds(d.getSeconds() + 300);
            let otpCode = makeid(4);
            let newOtp = OTPMaster();
            newOtp.ccode = ccode;
            newOtp.phone = phone;
            newOtp.otp = otpCode;
            newOtp.expireAt = d;
            await newOtp.save();

            sendSMS(`your verification code is ${otpCode}`, `+${ccode}${phone}`)
            return res.send(formatter.formatResponse({ otpCode }, 1, "otp_send", true));

        } else {
            let userResponseObj = await UserMaster.findOne({ phone: phone, user_type: "veterinarian", ccode: ccode, deleted_at: null }).setOptions({ ignorePreHooks: true });


            // console.log("userResponseObj========" + userResponseObj);


            if (!userResponseObj) {
                return res.send(formatter.formatResponse({}, 0, "not_registered_phone", false))
            }

            if (userResponseObj.user_type == 'veterinarian' && userResponseObj.is_suspended == true) {
                var finalRes = formatter.formatResponse({}, 10, config.messages["doctor_is_suspend"], false);
                return res.send(finalRes);
            }

            let d;
            d = new Date();
            d.setSeconds(d.getSeconds() + 300);
            let otpCode = makeid(4);
            let newOtp = OTPMaster();
            newOtp.ccode = ccode;
            newOtp.phone = phone;
            newOtp.otp = otpCode;
            newOtp.expireAt = d;
            await newOtp.save();

            sendSMS(`your verification code is ${otpCode}`, `+${ccode}${phone}`)
            return res.send(formatter.formatResponse({ otpCode }, 1, "otp_send", true));

        }
    } catch (errorCode) {
        console.error("userController.sendOtp- ", errorCode);
        return res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.signUp = async (req, res) => {
    const { email, fname, lname, pet_type, specialization, price, bio, device_type, device_token, phone, ccode, otp } = req.body;
    try {
        let checkUser = await UserMaster.findOne({ phone, ccode, user_type: "veterinarian" }).exec();
        if (checkUser != null) {
            if (req.files.profile) {
                fs.unlinkSync(publicPath + "profile/" + req.files.profile[0].filename);
            }
            if (req.files.document) {
                fs.unlinkSync(publicPath + "profile/" + req.files.document[0].filename);
            }
            return res.send(formatter.formatResponse({}, 0, "already_register", false))
        }
        else {
            let chckOtp = await OTPMaster.findOne({ ccode, phone, otp });

            if (!chckOtp) {
                if (req.files.profile) {
                    fs.unlinkSync(publicPath + "profile/" + req.files.profile[0].filename);
                }
                if (req.files.document) {
                    fs.unlinkSync(publicPath + "profile/" + req.files.document[0].filename);
                }
                return res.send(formatter.formatResponse({}, 0, "invalid_otp", false))
            }
            await chckOtp.delete()

            let profile = req.files.profile ? (req.files.profile[0].filename ?? '') : '';
            let document = req.files.document ? (req.files.document[0].filename ?? '') : '';
            let user = new UserMaster();
            user.email = email;
            user.phone = phone;
            user.ccode = ccode;
            user.fname = fname;
            user.lname = lname;
            user.pet_type = pet_type;
            user.user_type = "veterinarian";
            user.profile = profile;
            user.specialization = specialization;
            user.price = price;
            user.bio = bio;
            user.document = document
            user.device_type = device_type;
            user.device_token = device_token;
            user.save(async function (error, document) {
                if (error) {
                    let errorKeys = Object.keys(error.errors);

                    errorKeys.forEach(key => {
                        console.log(error.errors[key].properties.message);
                        res.send(formatter.formatResponse({}, 0, error.errors[key].properties.message, false))
                    });
                }
                if (document) {
                    // OTP sent to mobile setup
                    res.send(formatter.formatResponse(document, 1, "Login_success", true));
                }

            });
        }
    } catch (errorCode) {
        if (req.files.profile) {
            fs.unlinkSync(publicPath + "profile/" + req.files.profile[0].filename);
        }
        if (req.files.document) {
            fs.unlinkSync(publicPath + "profile/" + req.files.document[0].filename);
        }
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.verifyOTP = async (req, res) => {
    const { phone, ccode, otp, device_token = "", device_type = "" } = req.body;
    try {
        let userResponseObj = await UserMaster.findOne({ phone, ccode, user_type: "veterinarian", deleted_at: null }).setOptions({ ignorePreHooks: true });

        if (userResponseObj) {
            if (userResponseObj && userResponseObj.is_suspended) {
                return res.send(formatter.formatResponse({}, 10, "doctor_is_suspend", false));
            }
            let chckOtp = await OTPMaster.findOne({ ccode, phone, otp });
            if (chckOtp) {
                await chckOtp.delete()

                let user = await UserMaster.findByIdAndUpdate({ _id: userResponseObj._id }, { device_token: device_token, device_type: device_type });

                if (user != null && user.user_type == "veterinarian" && user.is_suspended == true) {
                    console.error("authorize failure - ");
                    var finalRes = formatter.formatResponse({}, 10, config.messages["doctor_is_suspend"], false);
                    return res.send(finalRes);
                }

                let token = jwt.sign({ _id: userResponseObj._id }, config.jwt.secret, { expiresIn: config.jwt.token_expiry });
                userResponseObj._doc.token = token;
                userResponseObj._doc.device_token = device_token;
                userResponseObj._doc.device_type = device_type;
                res.send(formatter.formatResponse(userResponseObj, 1, "otp_verified", true))
            } else {
                return res.send(formatter.formatResponse({}, 0, "invalid_otp", false))
            }
        }
        else {
            res.send(formatter.formatResponse({}, 0, "incorrect_phone", false))
        }
    } catch (errorCode) {
        console.error("userController.verifyOTP- ", errorCode);
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.updateVeterinarian = async function (req, res) {
    const { user_id, fname, lname, specialization, price, bio, pet_type } = req.body;
    try {
        // console.log("req.files========>", req.files)

        let veterinarian = await UserMaster.findOne({ _id: user_id, user_type: "veterinarian", deleted_at: null }).setOptions({ ignorePreHooks: true })
        if (req.files.profile || req.files.document) {

            // console.log("req.files.profile[0].filename=========", req.files.profile[0].filename)
            let profile = req.files.profile ? req.files.profile[0].filename : veterinarian.profile;
            let document_file = req.files.document ? req.files.document[0].filename : veterinarian.document;
            // console.log('document_file',document_file)


            if (veterinarian && veterinarian.profile) {
                fs.unlink(publicPath + "profile/" + veterinarian.profile, (err) => {
                    if (err) {
                        console.error(err);
                    }
                    console.log('profile file removed');
                })
            }

            if (veterinarian && veterinarian.document) {
                fs.unlink(publicPath + "profile/" + veterinarian.document, (err) => {
                    if (err) {
                        console.error(err);
                    }
                    console.log('document file removed');
                })
            }

            let update = await UserMaster.findOneAndUpdate({ _id: user_id, user_type: "veterinarian", deleted_at: null }, {
                profile: profile,
                document: document_file,
                fname: fname,
                lname: lname,
                specialization: specialization,
                price: price,
                bio: bio,
                pet_type: pet_type
            }, { new: true }).setOptions({ ignorePreHooks: true })

            if (update) return res.send(formatter.formatResponse(update, 1, "profile_update", true));
            else return res.send(formatter.formatResponse({}, 0, "invalid_user_id", false));
        } else {
            const update = await UserMaster.findOneAndUpdate({ _id: user_id, user_type: "veterinarian", deleted_at: null }, { fname: fname, lname: lname, specialization: specialization, price: price, bio: bio, pet_type: pet_type }, { new: true }).setOptions({ ignorePreHooks: true })
            if (update) return res.send(formatter.formatResponse(update, 1, "profile_update", true));
            else return res.send(formatter.formatResponse({}, 0, "invalid_user_id", false));
        }
    } catch (errorCode) {
        if (req.file && req.file.profile) {
            fs.unlink(
                publicPath + "profile/" + req.file.profile.filename,
                (err) => {
                    if (err) {
                        console.error(err);
                    }
                    console.log("file removed");
                }
            );
        }
        return res.send(formatter.formatResponse({}, 0, errorCode, false));
    }
}


veterinarianController.petTypeList = async (req, res) => {
    try {
        let image_path = global.APP_URL + "/public/petType/"
        let petTypeList = await PetTypeMaster.aggregate([
            {
                $project: {
                    pet_name: 1,
                    pet_image: { $concat: [image_path, "$pet_image"] }
                }
            },
            {
                $lookup: {
                    from: "breed_and_species_master",
                    localField: "_id",
                    foreignField: "pet_type_id",
                    as: "species",
                    pipeline: [
                        {
                            $match: {
                                type: "species",
                            }
                        }
                    ]
                }
            },
            {
                $lookup: {
                    from: "breed_and_species_master",
                    localField: "_id",
                    foreignField: "pet_type_id",
                    as: "breed",
                    pipeline: [
                        {
                            $match: {
                                type: "breed",
                            }
                        }
                    ]
                }
            },
        ])
        res.send(formatter.formatResponse(petTypeList, 1, "list_success", true))
    } catch (errorCode) {
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.productList = async (req, res) => {
    try {
        let { productType } = req.body;

        let productList = await ProductMaster.find({ productType: productType })
        res.send(formatter.formatResponse(productList, 1, "list_success", true))
    } catch (errorCode) {
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.productSearch = async (req, res) => {
    try {
        let productSearch = await ProductMaster.find({
            name: { $regex: new RegExp(req.query.name, 'i') }
        })
        res.send(formatter.formatResponse(productSearch, 1, "list_success", true))
    } catch (errorCode) {
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.requestedAppointmentList = async (req, res) => {
    try {
        let appointmentList = await ConsultationMaster.find({ doctor: req.user._id, status: "pending", payment: "success" }).sort({ _id: -1 })
            .populate({
                path: 'user',
                select: {
                    fname: 1,
                    lname: 1,
                    is_hide: 1,
                    is_suspended: 1,
                    deleted_at: 1
                },
                options: { ignorePreHooks: true } // Custom option to ignore hooks
            })
            .populate('pet', 'name breed pet_type gender dob pet_profile')
            .setOptions({ ignorePreHooks: true });
        res.send(formatter.formatResponse(appointmentList, 1, "list_success", true))
    } catch (errorCode) {
        console.error("userController.verifyOTP- ", errorCode);
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}
veterinarianController.upcomingAppointmentList = async (req, res) => {
    try {
        let appointmentList = await ConsultationMaster.find({ doctor: req.user._id, status: "accept" }).sort({ _id: -1 })
            .populate({
                path: 'user',
                select: {
                    fname: 1,
                    lname: 1,
                    is_hide: 1,
                    is_suspended: 1,
                    isDeleted: {
                        $cond: { if: { $eq: ["$deleted_at", null] }, then: false, else: true }
                    }
                },
                options: { ignorePreHooks: true } // Custom option to ignore hooks
            }).populate('pet', 'name breed pet_type gender dob pet_profile').setOptions({ ignorePreHooks: true });
        res.send(formatter.formatResponse(appointmentList, 1, "list_success", true))
    } catch (errorCode) {
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.appointmentStatus = async (req, res) => {
    const { _id, sender_id, status } = req.body;
    try {
        if (status == "accept") {
            let oldConsultation = await ConsultationMaster.findOne({ _id: _id })

            let existConsultation = await ConsultationMaster.findOne({ user: sender_id, doctor: req.user._id, status: { $in: ["pending", "accept"] }, payment: "success", created_at: { $lt: oldConsultation?.created_at } }).setOptions({ ignorePreHooks: true });

            // let existConsultation = await ConsultationMaster.aggregate([
            //     {
            //         $match: {
            //             user: sender_id,
            //             doctor: req.user._id,
            //             status: { $in: ["pending", "accept"] },
            //             payment: "success",
            //             created_at: { $lt: oldConsultation?.created_at }
            //         }
            //     },
            //     {
            //         $sort: { created_at: -1 } // Optional: If you want to sort the results by created_at in descending order
            //     },
            //     {
            //         $limit: 1 // Optional: To ensure you get only one document
            //     }
            // ]);

            // console.log("===================",existConsultation)
            // console.log("veterinarianController.appointmentStatus= ~ existConsultation:", existConsultation)
            if (existConsultation) {
                return res.send(formatter.formatResponse({}, 0, "user_old_consultation_pending", false));
            }
        }

        let checkAppointment = await ConsultationMaster.findOneAndUpdate(
            { user: sender_id, _id: _id, doctor: req.user._id },
            { status: status },
            { new: true }
        ).populate('user');

        if (!checkAppointment) {
            return res.send(formatter.formatResponse({}, 0, "not_found", false));
        }

        // add fees in wallet
        if (checkAppointment.status == "accept" && checkAppointment.appointment_type == "Instant") {

            let fee = checkAppointment.fee * (1 - (process.env.admin_charge / 100)).toFixed(2)
            await UserMaster.findOneAndUpdate({ _id: req.user._id }, { $inc: { wallet: fee } }, { new: true })
            await AdminMaster.findOneAndUpdate({ _id: commonConfig.AdminId }, { $inc: { wallet: checkAppointment.fee } }, { new: true })
            let transactionDetails = await TransactionMaster.findOne({ user_id: sender_id, msg: 'Instant Consultation fees', receiver_id: null }).sort({ _id: -1 })
            transactionDetails.receiver_id = req.user._id
            await transactionDetails.save()

            //remove extra consultaion and notification if consultation_type == instant
            await ConsultationMaster.deleteMany({ pet: ObjectId(checkAppointment.pet), issue: checkAppointment.issue, user: ObjectId(checkAppointment?.user?._id), payment: checkAppointment.payment, status: 'pending' })
            await NotificationMaster.deleteMany({ consultation_id: { $ne: checkAppointment._id }, pet_id: checkAppointment.pet, sender_id: checkAppointment?.user?._id, status: 'pending', msg: "New Instant Consultation Booked" })
        }

        // remove extra consultation
        // if (checkAppointment.status == "accept") {
        // }

        var findDeviceToken = await UserMaster.findOne({ _id: sender_id, deleted_at: null });
        if (findDeviceToken) {

            if (status != "complete") {
                await NotificationMaster.findOneAndUpdate(
                    { sender_id: sender_id, receiver_id: req.user._id, status: "pending" },
                    { status: status },
                    { new: true }
                );
            }

            // remove extra Notification
            // if (checkAppointment.status == "accept") await NotificationMaster.deleteMany({ consultation_id: { $ne: checkAppointment._id }, pet_id: checkAppointment.pet, sender_id: checkAppointment?.user?._id, status: 'pending', msg: "New Instant Consultation Booked" })

            let loginUser = await UserMaster.findOne({ _id: req.user._id });

            let messageContent = '';
            // let notificationMsg = '';
            let firebaseMsg = '';

            switch (status) {
                case "accept":
                    messageContent = 'Consultation Accepted';
                    // notificationMsg = `Your consultation is accepted by ${req.user.fname} ${req.user.lname}`;
                    firebaseMsg = `Your Consultation Has Been Accepted by Dr.${loginUser.fname} ${loginUser.lname}`;
                    break;
                case "complete":
                    messageContent = 'Consultation Completed';
                    // notificationMsg = `Your consultation is completed by ${req.user.fname} ${req.user.lname}`;
                    firebaseMsg = `Your Consultation Has Been Completed by Dr.${loginUser.fname} ${loginUser.lname}`;
                    break;
                default:
                    messageContent = 'Consultation Rejected';
                    // notificationMsg = `Your consultation is rejected by ${req.user.fname} ${req.user.lname}`;
                    firebaseMsg = `Your Consultation Has Been Rejected by Dr.${loginUser.fname} ${loginUser.lname}`;
                    break;
            }

            await MessageMaster.create({
                sender_id: req.user._id,
                receiver_id: sender_id,
                msg: checkAppointment._id,
                msg_type: messageContent
            });

            if ((checkAppointment.appointment_type == "Scheduled") || (checkAppointment.appointment_type == "Instant" && status == "accept")) {
                let notification = new NotificationMaster({
                    sender_id: req.user._id,
                    receiver_id: sender_id,
                    msg: firebaseMsg,
                });
                await notification.save();
            }


            if (findDeviceToken && findDeviceToken.device_token) {
                await sendFirebaseNotification(findDeviceToken.device_token, 'VETZY', firebaseMsg);
            }

            if (status == "reject") {
                let refund = await returnPayment(checkAppointment.chargeId)
                await AdminMaster.findOneAndUpdate({ email: config.AdminEmail }, { $inc: { wallet: -checkAppointment.fee } })
                if (refund && refund.id) {
                    await TransactionMaster.create({
                        user_id: req.user._id,
                        receiver_id: sender_id,
                        transaction_id: refund.id,
                        price: checkAppointment.fee,
                        msg: "Refund Payment"
                    })
                }
            }

            res.send(formatter.formatResponse(checkAppointment, 1, "list_success", true));

        } else {
            res.send(formatter.formatResponse({}, 0, "user_not_found", false));
        }
    } catch (errorCode) {
        res.send(formatter.formatResponse({}, 0, errorCode, false));
    }
};

veterinarianController.createPricribe = async (req, res) => {
    let { user, consultation, product_arr } = req.body
    try {
        let prod_price = 0
        for (i of product_arr) {
            prod_price += i.price * i.quantity
        }
        let findPet = await ConsultationMaster.findOne({ _id: consultation })
        let findDeviceToken = await UserMaster.findOne({ _id: user })
        let doctorDetails = await UserMaster.findOne({ _id: req.user._id })

        let priscribe = await PriscribeMaster({
            user: user,
            pet_id: findPet.pet,
            doctor: req.user._id,
            consultation: findPet._id,
            product_arr: product_arr,
            subtotal: prod_price,
            shipping: process.env.shipping_charge
        })
        await priscribe.save();
        await MessageMaster({
            sender_id: req.user._id,
            receiver_id: user,
            msg: priscribe._id,
            seen: false,
            msg_type: 'Prescribe Medicine'
        }).save()

        let pricribeData = {
            user_id: priscribe.user.toString(),
            pet_id: priscribe.pet_id.toString(),
            doctor_id: priscribe.doctor.toString(),
            consultation_id: priscribe.consultation.toString(),
            pet_id: priscribe.pet_id.toString(),
        }
        new NotificationMaster({
            sender_id: req.user._id,
            receiver_id: user,
            msg: `Dr.${doctorDetails.fname} ${doctorDetails.lname} Has Prescribed an E-Prescription for Your Consultation`,
        }).save()
        if (findDeviceToken && findDeviceToken.device_token) {
            sendFirebaseNotification(findDeviceToken.device_token, 'VETZY', `Dr.${doctorDetails.fname} ${doctorDetails.lname} Has Prescribed an E-Prescription for Your Consultation`, pricribeData)
        }
        res.send(formatter.formatResponse({ priscribe }, 1, "pricribe_created", true))
    } catch (errorCode) {
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}
veterinarianController.consultationHistory = async (req, res) => {
    try {
        let history = await ConsultationMaster.aggregate([
            { $match: { doctor: req.user._id, $or: [{ status: 'complete' }, { status: 'reject' }] } },
            {
                $lookup: {
                    from: 'user_master',
                    localField: 'user',
                    foreignField: '_id',
                    as: 'user_detail',
                    pipeline: [
                        {
                            $project: {
                                fname: 1,
                                lname: 1,
                            }
                        }
                    ]
                }
            },
            {
                $lookup: {
                    from: 'pricribe_master',
                    localField: '_id',
                    foreignField: 'consultation',
                    pipeline: [
                        {
                            $lookup: {
                                from: 'product_master',
                                localField: 'product_arr.product',
                                foreignField: '_id',
                                as: 'product_details'
                            }
                        },
                        {
                            $unwind: '$product_arr'
                        },
                        {
                            $addFields: {
                                product_details: {
                                    $mergeObjects: [
                                        { $arrayElemAt: ['$product_details', 0] },
                                        {
                                            product_image: {
                                                $concat: [global.APP_URL + '/public/product/', { $arrayElemAt: ['$product_details.product_image', 0] }]
                                            }
                                        }
                                    ]
                                }
                            }
                        }
                    ],
                    as: 'prescriptions'
                }
            },
            {
                $lookup: {
                    from: 'pet_master',
                    localField: 'pet',
                    foreignField: '_id',
                    as: 'pet'
                }
            },

            {
                $addFields: {
                    image: {
                        $map: {
                            input: '$image',
                            as: 'img',
                            in: {
                                $mergeObjects: ['$$img', {
                                    image: {
                                        $concat: [global.APP_URL + '/public/pet/', '$$img.image']
                                    }
                                }]
                            }
                        }
                    }
                }
            }
        ]);
        res.send(formatter.formatResponse(history, 1, "list_success", true))
    } catch (errorCode) {
        console.error("userController.verifyOTP- ", errorCode);
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.notificationList = async (req, res) => {
    try {
        // let list = await NotificationMaster.find({ receiver_id: req.user._id }).sort({ created_at: -1 }).populate({
        //     path: 'sender_id',
        //     select: 'fname lname',
        //     match: { customCondition: true }
        // }).setOptions({ ignorePreHooks: true })
        let list = await NotificationMaster.aggregate([
            { $match: { receiver_id: req.user._id } },
            { $sort: { created_at: -1 } },
            {
                $lookup: {
                    from: 'user_master',
                    localField: 'sender_id',
                    foreignField: '_id',
                    as: 'userSender'
                }
            },
            {
                $lookup: {
                    from: 'admin_masters',
                    localField: 'sender_id',
                    foreignField: '_id',
                    as: 'adminSender'
                }
            },
            {
                $addFields: {
                    sender: {
                        $concatArrays: ['$userSender', '$adminSender']
                    }
                }
            },
            {
                $unwind: {
                    path: '$sender',
                    preserveNullAndEmptyArrays: true
                }
            },
            {
                $project: {
                    _id: 1,
                    pet_id: 1,
                    consultation_id: 1,
                    msg: 1,
                    msg_type: 1,
                    appointment_type: 1,
                    status: 1,
                    created_at: 1,
                    updated_at: 1,
                    "sender._id": 1,
                    "sender.fname": 1,
                    "sender.lname": 1,
                    receiver: "$receiver_id"
                }
            }
        ])

        res.send(formatter.formatResponse(list, 1, "list_success", true))
    } catch (errorCode) {
        console.error("userController.verifyOTP- ", errorCode);
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.acceptNotification = async (req, res) => {
    const { notifi_id, status } = req.body
    try {
        let notificationStatue = await NotificationMaster.findOneAndUpdate({ _id: notifi_id }, { status: status }, { new: true })
        if (!notificationStatue) {
            deferred.reject('invalid_notifi_id')
        }

        let updateAppoStatus = await ConsultationMaster.findOneAndUpdate({ _id: notificationStatue.consultation_id, user: notificationStatue.sender_id, doctor: notificationStatue.receiver_id, pet: notificationStatue.pet_id }, { status: status }, { new: true })
        if (!updateAppoStatus) {
            deferred.reject('consultation_data_found')
        }

        if (status == 'accept') {
            if (updateAppoStatus.appointment_type == "Instant") {
                let fee = updateAppoStatus.fee * (1 - (process.env.admin_charge / 100)).toFixed(2)
                await UserMaster.findOneAndUpdate({ _id: req.user._id }, { $inc: { wallet: fee } }, { new: true })
                await AdminMaster.findOneAndUpdate({ _id: commonConfig.AdminId }, { $inc: { wallet: updateAppoStatus.fee } }, { new: true })
                await TransactionMaster.findOneAndUpdate({ user_id: updateAppoStatus.user, msg: 'Instant Consultation fees', receiver_id: null }, { receiver_id: req.user._id })
            }
            //delete extra notification
            await NotificationMaster.deleteMany({ consultation_id: { $ne: notificationStatue.consultation_id }, pet_id: notificationStatue.pet_id, sender_id: notificationStatue.sender_id, status: 'pending', msg: "New Instant Consultation Booked" })
            //delete extra consultaion
            await ConsultationMaster.deleteMany({ pet: ObjectId(updateAppoStatus.pet), issue: updateAppoStatus.issue, user: ObjectId(updateAppoStatus.user), payment: updateAppoStatus.payment, status: 'pending' })
            res.send(formatter.formatResponse(notificationStatue, 1, "notification_accepted", true))
        } else {
            res.send(formatter.formatResponse(notificationStatue, 1, "notification_rejected", true))
        }
    } catch (errorCode) {
        console.error("userController.verifyOTP- ", errorCode);
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.walletAmount = async (req, res) => {
    try {
        let walletAmt = await UserMaster.findOne({ _id: req.user._id })
        res.send(formatter.formatResponse(walletAmt.wallet.toFixed(2), 1, "list_success", true))
    } catch (errorCode) {
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.addBankDetail = async (req, res) => {
    const { bank_name, email, country_code, phone, dob, identify_number, city, country, address, postal_code, state, external_account_country, external_account_currency, bank_account_number, routing_number } = req.body
    try {
        let existBank = await BankDetailsMaster.findOne({ doctor_id: req.user._id })
        let userName = await UserMaster.findOne({ _id: req.user._id })
        if (!existBank) {
            let front_img = req.files.front_image ? req.files.front_image[0].filename : ""
            let back_img = req.files.back_image ? req.files.back_image[0].filename : ""
            let bankDetail = new BankDetailsMaster({
                doctor_id: req.user._id, bank_name: bank_name, lname: userName.fname, fname: userName.lname, email: email, country_code: country_code, phone: phone, dob: moment(dob).format('YYYY-MM-DD'), identify_number: identify_number, city: city, country: country, address: address, postal_code: postal_code, state: state, external_account_country: external_account_country, external_account_currency: external_account_currency, bank_account_number: bank_account_number, routing_number: routing_number,
                front_image: front_img,
                back_image: back_img
            })
            let userObj = {
                email: email,
                fname: userName.fname,
                lname: userName.lname,
                bank_name: bank_name,
                bdate: new Date(dob).getDate().toString(),
                bmonth: (new Date(dob).getMonth() + 1).toString(),
                byear: new Date(dob).getFullYear().toString(),
                identity_number: '10563145-8',
                city: 'Dubai',
                country: 'AE',
                address_line1: 'Dubai',
                pincode: '500001',
                state: 'Abu Dhabi',
                external_account_country: 'AE',
                external_account_currency: 'AED',
                acc_number: '000123456789',
                routing_number: '110000000',
            }

            let subAccountId = await createSubAccount("192.168.29.71", userObj, front_img, back_img)
            console.log("🚀 ~ veterinarianController.addBankDetail= ~ subAccountId:", subAccountId)
            if (subAccountId) {
                await bankDetail.save();
                console.log("🚀 ~ veterinarianController.addBankDetail= ~ subAccountId?.individual:", subAccountId?.individual)
                await UserMaster.findOneAndUpdate({ _id: req.user._id }, { AccountId: subAccountId?.individual?.account }, { new: true })
            }
            res.send(formatter.formatResponse(bankDetail, 1, "bank_added", true))
        } else {
            res.send(formatter.formatResponse({}, 0, "bank_already_added", false))
        }
    } catch (errorCode) {
        console.error("userController.verifyOTP- ", errorCode);
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.bankDetail = async (req, res) => {
    try {
        let bankDetail = await BankDetailsMaster.findOne({ doctor_id: req.user._id })
        if (bankDetail) {
            res.send(formatter.formatResponse(bankDetail, 1, "list_success", true))
        } else {
            res.send(formatter.formatResponse({}, 1, "list_success", true))
        }
    } catch (errorCode) {
        console.error("userController.verifyOTP- ", errorCode);
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.updateBankDetail = async (req, res) => {
    const { bank_name, email, dob, identify_number, city, country, address, postal_code, state, external_account_country, external_account_currency, bank_account_number, routing_number } = req.body
    try {
        let findUserBank = await BankDetailsMaster.findOne({ doctor_id: req.user._id })
        let LoginUser = await UserMaster.findOne({ _id: req.user._id })
        let front_img = req.files.front_image ? req.files.front_image[0].filename : findUserBank.front_image
        let back_img = req.files.back_image ? req.files.back_image[0].filename : findUserBank.back_image

        let userObj = {
            email: email ? email : findUserBank.email,
            account_id: LoginUser.AccountId,
            fname: LoginUser.fname,
            lname: LoginUser.lname,
            // bank_name: bank_name,
            phone: '+17049424852',
            // bdate: new Date(dob).getDate().toString(),
            // bmonth: (new Date(dob).getMonth() + 1).toString(),
            // byear: new Date(dob).getFullYear().toString(),
            // identity_number: '10563145-8',
            city: 'CHARLOTTE',
            country: 'US',
            address_line1: '11155 SAINTSBURY PL',
            pincode: '28270',
            state: 'North Carolina',
            // external_account_country: 'US',
            // external_account_currency: 'USD',
            acc_number: '000123456789',
            routing_number: '110000000',
        }

        let updateBank = await updateSubAccount(userObj)
        let updateAccountId = await UserMaster.findOneAndUpdate({ _id: req.user._id }, { AccountId: updateBank.individual.account }, { new: true })
        if (updateAccountId) {
            if (req.files) {
                if (findUserBank.front_image && req.files.front_image) {
                    fs.unlinkSync(publicPath + 'document/' + findUserBank.front_image)
                }
                if (findUserBank.back_image && req.files.back_image) {
                    fs.unlinkSync(publicPath + 'document/' + findUserBank.back_image)
                }
                let updateBank = await BankDetailsMaster.findOneAndUpdate({ doctor_id: req.user._id }, { bank_name, email, front_image: front_img, back_image: back_img, bank_name, dob, identify_number, city, country, address, postal_code, state, external_account_country, external_account_currency, bank_account_number, routing_number, }, { new: true })
                res.send(formatter.formatResponse(updateBank, 1, "bank_updated", true))
            } else {
                let updateBank = await BankDetailsMaster.findOneAndUpdate({ doctor_id: req.user._id }, { bank_name, email, dob, identify_number, city, country, address, postal_code, state, external_account_country, external_account_currency, bank_account_number, routing_number }, { new: true })
                res.send(formatter.formatResponse(updateBank, 1, "bank_updated", true))
            }
        }
    } catch (errorCode) {
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.withdrawAmount = async (req, res) => {
    const { amount } = req.body
    try {
        let loginUser = await UserMaster.findOne({ _id: req.user._id })
        if (loginUser && loginUser.wallet < amount) {
            return res.send(formatter.formatResponse({}, 0, "insufficient_balance", false))
        }
        if (loginUser && loginUser.AccountId) {
            await PayoutHistoryMaster.create({
                user_id: req.user._id,
                amount: amount,
            })
            // let payout = await payoutStripe(amount, loginUser.AccountId, 'withdraw amount')
            // if (payout) {
            //     loginUser.wallet -= amount
            //     await loginUser.save()
            // await PayoutHistoryMaster.create({
            //     user_id: req.user._id,
            //     amount: amount
            // })
            // }
            return res.send(formatter.formatResponse({}, 1, 'withdraw_req_sent', true))
        } else {
            return res.send(formatter.formatResponse({}, 0, "bank_not_add", false))
        }
    } catch (errorCode) {
        console.error("userController.verifyOTP- ", errorCode);
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.payoutHistory = async (req, res) => {
    try {
        let payoutHistory = await PayoutHistoryMaster.find({ user_id: req.user._id, is_withdraw: 'accept' })
        res.send(formatter.formatResponse(payoutHistory, 1, "list_success", true))
    } catch (errorCode) {
        console.error("userController.verifyOTP- ", errorCode);
        res.send(formatter.formatResponse({}, 0, errorCode, false))
    }
}

veterinarianController.refund = async (consultation_id) => {
    let consultationDtl = await ConsultationMaster.findOneAndUpdate({ _id: consultation_id }, { status: 'reject' }, { new: true })
    if (consultationDtl && consultationDtl.chargeId) {
        let refund = await returnPayment(consultationDtl.chargeId)
        const admin = await AdminMaster.findOneAndUpdate({ email: config.AdminEmail }, { $inc: { wallet: -consultationDtl.fee } }, { new: true })
        if (refund && refund.id) {
            console.log("🚀 ~ veterinarianController.refund= ~ refund.id:", refund.id)
            await TransactionMaster.create({
                user_id: admin._id,
                receiver_id: consultationDtl.user,
                transaction_id: refund.id,
                price: consultationDtl.fee,
                msg: "Refund Payment"
            })
        }
    }
}

veterinarianController.cronRefund = async () => {
    try {
        const instantConsultation = await ConsultationMaster.find({ appointment_type: "Instant", status: "pending", payment: "success" })
        if (instantConsultation.length > 0) {
            for (let consultation of instantConsultation) {
                let futureDate = new Date(consultation.created_at.getTime() + 20 * 60 * 1000)
                if (futureDate >= new Date()) {
                    await veterinarianController.refund(consultation._id)
                    // let consultationDtl = await ConsultationMaster.findOne({ _id: consultation })
                    // if (consultationDtl.chargeId) {
                    // let refund = await returnPayment(consultationDtl.chargeId)
                    // const admin = await AdminMaster.findOneAndUpdate({ email: config.AdminEmail }, { $inc: { wallet: -consultationDtl.fee } }, { new: true })
                    // if (refund && refund.id) {
                    //     await TransactionMaster.create({
                    //         user_id: admin._id,
                    //         receiver_id: req.user._id,
                    //         transaction_id: refund.id,
                    //         price: consultationDtl.fee,
                    //         msg: "Refund Payment"
                    //     })
                    // }
                    // }
                }
            }
        }
    } catch (errorCode) {
        console.error("cronRefund- ", errorCode);
    }
}


module.exports = veterinarianController