const mongoose = require("mongoose");
const Schema = mongoose.Schema;

const AddressMaster = new Schema(
    {
        user: { type: mongoose.Types.ObjectId, default: null, ref: "category_master", index: 1 },
        fname: { type: String, required: [true, "Please enter Name"] },
        lname: { type: String, required: [true, "Please enter Name"] },
        company_name: { type: String },
        country: { type: String, required: [true, "Please enter company name"] },
        line_1: { type: String, required: [true, "Please enter Street Address"] },
        line_2: { type: String, default: null },
        city: { type: String, required: [true, "Please enter City"] },
        state: { type: String },
        zipcode: { type: String },
        phone: { type: Number, required: [true, "Please enter Phone"] },
        email: { type: String, required: [true, "Please enter Email"] },
        notes: { type: String },
        is_default: { type: Boolean, default: false },
        created_at: { type: Date, default: Date.now },
        updated_at: { type: Date, default: Date.now },
        deleted_at: { type: Date, default: null },
    },
    {
        collection: "address_master",
        // name: 1,
        // collation: { locale: "en", strength: 2 },
    }
);

AddressMaster.pre('find', function () {

    if (this.options.ignorePreHooks) {
        return;
    }
    // this.where({ deleted_at: null,is_hide: false ,is_suspended: false});
    this.where({ deleted_at: null });
});

AddressMaster.pre('findOne', function () {
    if (this.options.ignorePreHooks) {
        return;
    }
    this.where({ deleted_at: null });
});

AddressMaster.pre('findById', function () {

    if (this.options.ignorePreHooks) {
        return;
    }
    this.where({ deleted_at: null });
});

AddressMaster.pre('findByIdAndUpdate', function () {

    if (this.options.ignorePreHooks) {
        return;
    }
    this.where({ deleted_at: null });
});
AddressMaster.pre('findOneAndUpdate', function () {
    if (this.options.ignorePreHooks) {
        return;
    }
    this.where({ deleted_at: null, is_suspended: false });
});

AddressMaster.statics = {
    /**
     * Single data
     * @param {*} filter
     * @returns
     */
    async get(id) {
        return this.findById(id).exec();
    },

    /**
     * list data
     * @param {*} filter
     * @returns
     */
    async list(filter = {}) {
        return this.find(filter).exec();
    },
};

// const publicPath = APP_URL + "/public/";

AddressMaster.methods.toJSON = function () {
    var obj = this.toObject();
    let objKeys = Object.keys(obj);
    objKeys.forEach(function (key) {
        if (obj[key] == null) {
            obj[key] = "";
        }
    });

    delete obj.created_at;
    delete obj.updated_at;
    delete obj.deleted_at;
    delete obj.__v;

    return obj;
};

module.exports = mongoose.model("address_master", AddressMaster);
