const mongoose = require('mongoose');

const adminSchema = new mongoose.Schema({
    name: { type: String, required: [true, "Please enter name"] },
    email: { type: String, required: [true, "Please enter Email"], index: 1 },
    password: { type: String, required: [true, "Please enter Password"] },
    otp: { type: String, default: null },
    wallet: { type: Number, default: 0 },
    device_type: { type: String, enum: ['iOS', 'android'] },
    device_token: { type: String, default: null },
    token: { type: String, default: '' },
    deleted_at: { type: Date, default: null },
}, { timestamps: true });

const adminModel = mongoose.model('admin_master', adminSchema);

module.exports = adminModel