const mongoose = require("mongoose");

const BankDetailsMasterSchema = new mongoose.Schema(
    {
        doctor_id: { type: mongoose.Types.ObjectId, index: 1 },
        bank_name: { type: String, required: [true, "Please enter bank name"] },
        fname: { type: String, required: [true, "Please enter fname"] },
        lname: { type: String, required: [true, "Please enter lname"] },
        email: { type: String, required: [true, "Please enter email"] },
        country_code: { type: String, required: [true, "Please enter country code"] },
        phone: { type: String, required: [true, "Please enter phone number"] },
        dob: { type: String, required: [true, "Please enter date of birth"] },
        identify_number: { type: String, required: [true, "Please enter identify number"] },
        city: { type: String, required: [true, "Please enter city"] },
        country: { type: String, required: [true, "Please enter country"] },
        address: { type: String, required: [true, "Please enter address"] },
        postal_code: { type: String, required: [true, "Please enter postal code"] },
        state: { type: String, required: [true, "Please enter state"] },
        external_account_country: { type: String, required: [true, "Please enter external account country"] },
        external_account_currency: { type: String, required: [true, "Please enter external account currency"] },
        bank_account_number: { type: String, required: [true, "Please enter bank account number"] },
        routing_number: { type: String, required: [true, "Please enter routing number"] },
        front_image: { type: String },
        back_image: { type: String },
    },
    { collection: "bank_detail_master", timestamps: true, }
);

const publicPath = global.APP_URL + "/public/";

BankDetailsMasterSchema.methods.toJSON = function () {
    var obj = this.toObject();
    let objKeys = Object.keys(obj);
    objKeys.forEach(function (key) {
        if (obj[key] == null) {
            obj[key] = "";
        }
    });

    delete obj.createdAt;
    delete obj.updatedAt;
    delete obj.__v;
    if (obj.front_image && obj.front_image != "") {
        obj.front_image = publicPath + "document/" + obj.front_image;
    }
    if (obj.back_image && obj.back_image != "") {
        obj.back_image = publicPath + "document/" + obj.back_image;
    }

    return obj;
};

module.exports = mongoose.model("BankDetailsMaster", BankDetailsMasterSchema);
