const mongoose = require("mongoose");
const Schema = mongoose.Schema;

const BreedAndSpeciesMaster = new Schema(
    {
        pet_type_id: { type: mongoose.Types.ObjectId, require, index: 1 },
        name: { type: String, require },
        type: { type: String, enum: ["species", "breed"], require }
    },
    { collection: "breed_and_species_master" }
);

BreedAndSpeciesMaster.methods.toJSON = function () {
    var obj = this.toObject();
    let objKeys = Object.keys(obj);
    objKeys.forEach(function (key) {
        if (obj[key] == null) {
            obj[key] = "";
        }
    });

    // delete obj.created_at;
    // delete obj.updated_at;
    // delete obj.deleted_at;
    delete obj.__v;
    if (obj.image && obj.image != "") {
        obj.image = global.APP_URL + "/public/issue/" + obj.image;
    }

    return obj;
};

module.exports = mongoose.model("breed_and_species_master", BreedAndSpeciesMaster);