const mongoose = require("mongoose");
const Schema = mongoose.Schema;

const BreedCategoryMaster = new Schema(
    {
        name: { type: String, required: [true, "Please enter Name"] },
        subCatId: { type: String, default: null },
        created_at: { type: Date, default: Date.now },
        updated_at: { type: Date, default: null },
        deleted_at: { type: Date, default: null },
    },
    {
        collection: "breed_category_master",
        name: 1,
        collation: { locale: "en", strength: 2 },
    }
);

BreedCategoryMaster.statics = {
    /**
     * Single data
     * @param {*} filter
     * @returns
     */
    async get(id) {
        return this.findById(id).exec();
    },

    /**
     * list data
     * @param {*} filter
     * @returns
     */
    async list(filter = {}) {
        return this.find(filter).exec();
    },
};


BreedCategoryMaster.methods.toJSON = function () {
    var obj = this.toObject();
    let objKeys = Object.keys(obj);
    objKeys.forEach(function (key) {
        if (obj[key] == null) {
            obj[key] = "";
        }
    });

    delete obj.created_at;
    delete obj.updated_at;
    delete obj.deleted_at;
    delete obj.__v;
    return obj;
};

module.exports = mongoose.model("breed_category_master", BreedCategoryMaster);
