const mongoose = require("mongoose");
const Schema = mongoose.Schema;

const PetTypeMaster = new Schema(
    {
        pet_name: { type: String },
        pet_image: { type: String }
    },
    { collection: "pet_type_master" }
);


PetTypeMaster.methods.toJSON = function () {
    var obj = this.toObject();
    let objKeys = Object.keys(obj);
    objKeys.forEach(function (key) {
        if (obj[key] == null) {
            obj[key] = "";
        }
    });

    delete obj.created_at;
    delete obj.updated_at;
    delete obj.deleted_at;
    delete obj.__v;
    if (obj.pet_image && obj.pet_image != "") {
        obj.pet_image = global.APP_URL + "/public/petType/" + obj.pet_image;
    }
    return obj;
};

module.exports = mongoose.model("pet_type_master", PetTypeMaster);
