const mongoose = require("mongoose");
const Schema = mongoose.Schema;

const pricribeMaster = new Schema(
    {
        user: { type: mongoose.Types.ObjectId, default: null, ref: "user_master", index: 1 },
        pet_id: { type: mongoose.Types.ObjectId, default: null, ref: "pet_master", index: 1 },
        doctor: { type: mongoose.Types.ObjectId, default: null, ref: "user_master", index: 1 },
        consultation: { type: mongoose.Types.ObjectId, default: null, ref: "consultation_master", index: 1 },
        subtotal: { type: Number, required: [true, "Please enter sub_total"] },
        product_arr: [
            {
                product: { type: mongoose.Types.ObjectId, ref: "product_master" },
                quantity: { type: Number, default: 1 },
                price: { type: Number, default: 0 },
                note: { type: Object }
            },
        ],
        shipping: { type: Number, default: 0 },
        is_buy: { type: Boolean, default: false },
        created_at: { type: Date, default: Date.now },
        updated_at: { type: Date, default: Date.now },
    },
    {
        collection: "pricribe_master",
        // name: 1,
        // collation: { locale: "en", strength: 2 },
    }
);

pricribeMaster.statics = {
    /**
     * Single data
     * @param {*} filter
     * @returns
     */
    async get(id) {
        return this.findById(id).exec();
    },

    /**
     * list data
     * @param {*} filter
     * @returns
     */
    async list(filter = {}) {
        return this.find(filter).exec();
    },
};

pricribeMaster.methods.toJSON = function () {
    var obj = this.toObject();
    let objKeys = Object.keys(obj);
    objKeys.forEach(function (key) {
        if (obj[key] == null) {
            obj[key] = "";
        }
    });

    // delete obj.created_at;
    delete obj.updated_at;
    delete obj.deleted_at;
    delete obj.__v;

    return obj;
};

module.exports = mongoose.model("pricribe_master", pricribeMaster);
