const mongoose = require("mongoose");
const Schema = mongoose.Schema;

const RecipesPurchaseMaster = new Schema(
    {
        userId: { type: mongoose.Types.ObjectId, default: null, ref: "user_master", index: 1 },
        recipes: { type: mongoose.Types.ObjectId, default: null, ref: "breed_recipes_master", index: 1 },
        speciesId: { type: mongoose.Types.ObjectId, default: null, ref: "breed_category_master", index: 1 },
        breedId: { type: mongoose.Types.ObjectId, default: null, ref: "breed_category_master", index: 1 },
        isPaid: { type: Boolean, default: false },
        isNeutered: { type: Boolean, default: false },
        activityLevel:{ type: String, default:"" },
        supplementName: { type: String, default:"" },
        supplementDesc: { type: String, default:"" },
        calories: { type: Number, default:null},
        weight: { type: Number, default:null},
        age: { type: Number, default:null},
        created_at: { type: Date, default: Date.now },
        updated_at: { type: Date, default: null },
        deleted_at: { type: Date, default: null },
    },
    {
        collection: "recipes_purchase_master",
        name: 1,
        collation: { locale: "en", strength: 2 },
    }
);

RecipesPurchaseMaster.statics = {
    /**
     * Single data
     * @param {*} filter
     * @returns
     */
    async get(id) {
        return this.findById(id).exec();
    },

    /**
     * list data
     * @param {*} filter
     * @returns
     */
    async list(filter = {}) {
        return this.find(filter).exec();
    },
};


RecipesPurchaseMaster.methods.toJSON = function () {
    var obj = this.toObject();
    let objKeys = Object.keys(obj);
    objKeys.forEach(function (key) {
        if (obj[key] == null) {
            obj[key] = "";
        }
    });

    delete obj.created_at;
    delete obj.updated_at;
    delete obj.deleted_at;
    delete obj.__v;
    return obj;
};

module.exports = mongoose.model("recipes_purchase_master", RecipesPurchaseMaster);
