const mongoose = require("mongoose");
const Schema = mongoose.Schema;

const transactionMaster = new Schema({
    user_id: { type: mongoose.Types.ObjectId, default: null, ref: 'user_master', index: 1 },
    receiver_id: { type: mongoose.Types.ObjectId, default: null, ref: 'user_master', index: 1 },
    transaction_id: { type: String, default: null },
    price: { type: Number, required: [true, "Please enter Price"] },
    msg: { type: String },
    created_at: { type: Date, default: Date.now },
    updated_at: { type: Date, default: Date.now },
},
    { collection: "transaction_master", }
);

const publicPath = APP_URL + "/public/";
transactionMaster.methods.toJSON = function () {
    var obj = this.toObject();
    let objKeys = Object.keys(obj);
    objKeys.forEach(function (key) {
        if (obj[key] == null) {
            obj[key] = "";
        }
    });

    delete obj.__v;
    if (obj.receiver_id.profile && obj.receiver_id.profile != "") {
        obj.receiver_id.profile = publicPath + "profile/" + obj.receiver_id.profile;
    }
    return obj;
};

module.exports = mongoose.model("transaction_master", transactionMaster);
