const mongoose = require('mongoose');
const Schema = mongoose.Schema;

const promptHistoryMaster = new Schema({
    user_id: { type: Schema.Types.ObjectId, ref: 'user_master', index: 1 },
    date: { type: Date },
    // message: { type: String },
    history: {
        type: [
            {
                role: {
                    type: String,
                    enum: ['system', 'user', 'assistant'],
                    required: true
                },
                content: {
                    type: String,
                    required: true
                }
            }
        ],
        default: []
    },
    created_at: { type: Date, default: Date.now },
    updated_at: { type: Date, default: Date.now },
}, { collection: 'prompt_history_master' });

module.exports = mongoose.model('prompt_history_master', promptHistoryMaster);