const config = require('../config/common.config');
const jwt = require('jsonwebtoken');
const sendSMSNew = require('./sendSMSNew');

const decryptData = (key) => {
    return jwt.verify(key, config.jwt.secret)
}

const account_sid = decryptData(config.twilio.account_sid)
const auth_token = decryptData(config.twilio.auth_token)
const serviceSID = decryptData(config.twilio.messagingServiceSid)

// console.log("ðŸš€ ~ account_sid:", account_sid)
// console.log("ðŸš€ ~ auth_token:", auth_token)
// console.log("ðŸš€ ~ serviceSID:", serviceSID)

const twClient = require('twilio')(account_sid, auth_token);

const sendSMS = async function (msg, phone) {
    if (phone.includes("+971")) {
        await sendSMSNew(msg, phone);
    }
    else {
        twClient.messages.create({
            to: phone,
            // from: config.twilio.from_number,
            messagingServiceSid: serviceSID,
            body: msg
        }, async function (err, message) {
            if (err) {
                console.error("sendOTP twClient.messages.create failure - ", err);
                // console.error('We are not able to send message to ' + checkAdmin.phone);
            } else {
                console.log("text message sent successfully.");
            }
        });
    }
};
module.exports = sendSMS;