const config = require('../config/common.config');
const jwt = require('jsonwebtoken');

const decryptData = (key) => {
    return jwt.verify(key, config.jwt.secret)
}

const axios = require('axios');
const sendSMSNew = async function (msg, phone) {

    let data = JSON.stringify({
        "messages": [
            {
                "destinations": [
                    {
                        "to": phone
                    }
                ],
                "from": config.SMS_BIP.fromNumber,
                "text": msg
            }
        ]
    });

    let SMSconfig = {
        method: 'post',
        maxBodyLength: Infinity,
        url: 'https://' + config.SMS_BIP.API_BASE + '/sms/2/text/advanced',
        headers: {
            'Authorization': 'App ' + decryptData(config.SMS_BIP.API_KEY),
            'Content-Type': 'application/json',
            'Accept': 'application/json'
        },
        data: data
    };

    axios.request(SMSconfig)
        .then((response) => {
            console.log(JSON.stringify(response.data));
        })
        .catch((error) => {
            console.log(error);
        });

};
module.exports = sendSMSNew;
